## coq 8.14.0+dfsg

=== debian/changelog ===
coq (8.14.0+dfsg-4) unstable; urgency=medium

  * Strip libraries.
  * Build using dune directly.
  * Make the html doc point to a local logo file.
  * Make the html doc point to local css files.
  * Disable the bytecode-only architectures (Closes: #999651).

 -- Julien Puydt <jpuydt@debian.org>  Mon, 15 Nov 2021 06:59:19 +0100

coq (8.14.0+dfsg-3) unstable; urgency=medium

  * Add bash to the build-deps and generalize
  avoid-usr-bin-env.patch into a fix_debian_paths.patch ;
  made the other patches cope with it.
  * Add a patch to handle the timing scripts correctly.
  * Add a lintian override for false positive ocaml-dangling-cmi.
  * Add a lintian override for false positive
    shared-library-lacks-prerequisites.
  * Add a lintian override for maintainer-desktop-entry.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 13 Nov 2021 12:23:41 +0100

coq (8.14.0+dfsg-2) experimental; urgency=medium

  * Add myself to uploaders.
  * Bump standards-version to 4.6.0.
  * Rewrite avoid-usr-bin-env.patch.
  * Drop python-scripts-libraries.patch.
  * Drop skip-dot-pc.patch.
  * Make the whole patch stack work.
  * Update lintian overrides about wildcard in HTML filenames.
  * Point coq-theories.doc-base to the new path.
  * Enable hardening flags in d/rules.
  * Add keywords to coqide.desktop.
  * Remove debian-shipped coqide.1 -- now upstream.
  * Add lintian overrides for long lines is source code.

 -- Julien Puydt <jpuydt@debian.org>  Thu, 11 Nov 2021 17:40:04 +0100

coq (8.14.0+dfsg-1) experimental; urgency=medium

  * Non-maintainer upload.
  * Drop retired Enrico Tassi from uploaders (Closes: #995543).
  * Rework d/copyright, d/gbp.conf, d/README.source and d/watch
    so updating to a new upstream is cleaner and simpler.
  * New upstream release (update patches, d/rules...).

 -- Julien Puydt <jpuydt@debian.org>  Mon, 08 Nov 2021 07:43:58 +0100

=== debian/control ===
Source: coq
Section: math
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Benjamin Barenblat <bbaren@debian.org>,
 Julien Puydt <jpuydt@debian.org>,
 Ralf Treinen <treinen@debian.org>,
 Stéphane Glondu <glondu@debian.org>
Standards-Version: 4.6.0
Build-Depends:
 bash (>= 5.0),
 debhelper-compat (= 13),
 dh-exec,
 dh-ocaml (>= 0.9.5~),
 dh-python,
 ocaml-dune,
 ocaml-nox (>= 4.05),
 ocaml-findlib (>= 1.8.0),
 camlp5 (>= 6.14),
 liblablgtk3-ocaml-dev,
 liblablgtksourceview3-ocaml-dev (>= 3.0~beta8),
 libnum-ocaml-dev,
 libounit-ocaml-dev,
 libzarith-ocaml-dev,
 python3,
 rsync,
 tex-common
Build-Conflicts: libcoq-ocaml
Rules-Requires-Root: no
Homepage: http://coq.inria.fr/
Vcs-Browser: https://salsa.debian.org/ocaml-team/coq
Vcs-Git: https://salsa.debian.org/ocaml-team/coq.git

Package: coq
Architecture: amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x hurd-i386 ppc64 riscv64
Depends:
 coq-theories (= ${binary:Version}),
 ${ocaml:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
 ${misc:Depends},
 ocaml-nox,
 ocaml-findlib
Provides: coq-${F:CoqABI}
Suggests:
 coqide | proofgeneral,
 ledit | readline-editor,
 libcoq-ocaml-dev,
 why (>= 2.19),
 coq-doc
Breaks: coq-libs (<< 8.2.pl1)
Replaces: coq-libs (<< 8.2.pl1)
Description: proof assistant for higher-order logic (toplevel and compiler)
 Coq is a proof assistant for higher-order logic, which allows the
 development of computer programs consistent with their formal
 specification. It is developed using Objective Caml and Camlp5.
 .
 This package provides coqtop, a command line interface to Coq.
 .
 A graphical interface for Coq is provided in the coqide package.
 Coq can also be used with ProofGeneral, which allows proofs to be
 edited using emacs and xemacs. This requires the proofgeneral
 package to be installed.

Package: coqide
Architecture: amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x hurd-i386 ppc64 riscv64
Depends:
 coq (= ${binary:Version}),
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Description: proof assistant for higher-order logic (gtk interface)
 Coq is a proof assistant for higher-order logic, which allows the
 development of computer programs consistent with their formal
 specification. It is developed using Objective Caml and Camlp5.
 .
 This package provides CoqIde, a graphical user interface for
 developing proofs.

Package: coq-theories
Architecture: amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x hurd-i386 ppc64 riscv64
Depends: coq-${F:CoqABI}, ${misc:Depends}, ${shlibs:Depends}
Recommends: coq (>= 8.0)
Breaks: coq-doc (<= 8.0pl1.0-2), coq-libs (<< 8.2.pl1)
Replaces: coq-libs (<< 8.2.pl1)
Description: proof assistant for higher-order logic (theories)
 Coq is a proof assistant for higher-order logic, which allows the
 development of computer programs consistent with their formal
 specification. It is developed using Objective Caml and Camlp5.
 .
 This package provides existing theories that new proofs can be
 based upon, including theories of arithmetic and Boolean values.

Package: libcoq-ocaml
Section: ocaml
Architecture: amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x hurd-i386 ppc64 riscv64
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Breaks: coq (<< 8.3~), libcoq-ocaml-dev (<< 8.3~), coq-libs
Replaces: coq (<< 8.3~), libcoq-ocaml-dev (<< 8.3~), coq-libs
Description: runtime libraries for Coq
 Coq is a proof assistant for higher-order logic, which allows the
 development of computer programs consistent with their formal
 specification. It is developed using Objective Caml and Camlp5.
 .
 This package provides runtime libraries for Coq.

Package: libcoq-ocaml-dev
Section: ocaml
Architecture: amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x hurd-i386 ppc64 riscv64
Depends:
 coq (= ${binary:Version}),
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Breaks: coq (<< 8.2-1+dfsg-1), coq-libs (<< 8.2.pl1)
Replaces: coq (<< 8.2-1+dfsg-1), coq-libs (<< 8.2.pl1)
Description: development libraries and tools for Coq
 Coq is a proof assistant for higher-order logic, which allows the
 development of computer programs consistent with their formal
 specification. It is developed using Objective Caml and Camlp5.
 .
 This package provides and libraries needed to develop OCaml-side
 extensions to Coq.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/ocaml/ocamlvars.mk

COQ_VERSION := 8.14.0
COQ_ABI := $(COQ_VERSION)+$(OCAML_ABI)

PACKAGES := $(shell dh_listpackages)

export OCAMLINIT_SED += \
  -e 's%@CoqVersion@%$(COQ_VERSION)%' \
  -e 's%@CoqABI@%$(COQ_ABI)%'

%:
	+dh $@ --with ocaml,python3

build:
	+dh $@ --with ocaml,python3

override_dh_auto_configure:
	# none with dune

override_dh_auto_build:
	dune build -p coq-core,coq-stdlib,coqide-server,coqide --display=verbose
	dune build @stdlib-html --display=verbose
	# all the html files point to the same logo - ship it and point to it
	cp ide/coqide/coq.png _build/default/doc/stdlib/html/logo.png
	find _build/default/doc/stdlib/html/ -name "*.html" | xargs sed -i -e "s,//coq.inria.fr/files/barron_logo.png,logo.png,g"
	# all the html files point to some remote css - but they can be local too
	cp doc/common/styles/html/coqremote/modules/node/node.css _build/default/doc/stdlib/html/
	find _build/default/doc/stdlib/html/ -name "*.html" | xargs sed -i -e "s,//coq.inria.fr/modules/node/node.css,node.css,g"
	cp doc/common/styles/html/coqremote/modules/system/defaults.css _build/default/doc/stdlib/html/
	find _build/default/doc/stdlib/html/ -name "*.html" | xargs sed -i -e "s,//coq.inria.fr/modules/system/defaults.css,defaults.css,g"
	cp doc/common/styles/html/coqremote/modules/system/system.css _build/default/doc/stdlib/html/
	find _build/default/doc/stdlib/html/ -name "*.html" | xargs sed -i -e "s,//coq.inria.fr/modules/system/system.css,system.css,g"
	cp doc/common/styles/html/coqremote/modules/user/user.css _build/default/doc/stdlib/html/
	find _build/default/doc/stdlib/html/ -name "*.html" | xargs sed -i -e "s,//coq.inria.fr/modules/user/user.css,user.css,g"
	find _build/default/doc/stdlib/html/ -name "*.html" | xargs sed -i -e "s,//coq.inria.fr/sites/all/themes/coq/coqdoc.css,coqdoc.css,g"
	cp tools/coqdoc/style.css _build/default/doc/stdlib/html/
	find _build/default/doc/stdlib/html/ -name "*.html" | xargs sed -i -e "s,//coq.inria.fr/sites/all/themes/coq/style.css,style.css,g"

# Check that $(COQ_VERSION) has the right value
	ACTUAL_COQ_VERSION="$$(./_build/install/default/bin/coqc --version | awk '/version/{print $$6}')"; \
	if [ "$$ACTUAL_COQ_VERSION" != "$(COQ_VERSION)" ]; then \
	  echo "Please set COQ_VERSION to $$ACTUAL_COQ_VERSION in debian/rules"; \
	  exit 2; \
	fi

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# OCAMLPATH=$(CURDIR)/_build_vo/default/lib make -C test-suite COQBIN=$(CURDIR)/_build_vo/default/bin/ COQLIB=$(CURDIR)/_build_vo/default/lib/coq
	@echo "TESTS ARE DISABLED FOR NOW!"
endif

override_dh_auto_install:
	dune install coq-core coq-stdlib coqide-server coqide \
		--destdir=$(CURDIR)/debian/tmp --prefix=/usr --mandir=/usr/share/man
	mkdir -p $(CURDIR)/debian/tmp/usr/doc/coq-stdlib/html
	install -m 644 _build/default/doc/stdlib/html/* $(CURDIR)/debian/tmp/usr/doc/coq-stdlib/html
	# cleaning what upstream installs and we don't (need to) ship
	rm -rf  $(CURDIR)/debian/tmp/usr/doc/coq-core/LICENSE \
		$(CURDIR)/debian/tmp/usr/doc/coqide/odoc-pages \
		$(CURDIR)/debian/tmp/usr/doc/coqide/LICENSE \
		$(CURDIR)/debian/tmp/usr/doc/coqide-server \
		$(CURDIR)/debian/tmp/usr/doc/coq-stdlib/LICENSE \
		$(CURDIR)/debian/tmp/usr/doc/coq-stdlib/odoc-pages \
		$(CURDIR)/debian/tmp/usr/lib/coq-core/revision \
		$(CURDIR)/debian/tmp/usr/lib/coqide \
		$(CURDIR)/debian/tmp/usr/lib/coqide-server \
		$(CURDIR)/debian/tmp/usr/lib/coq-stdlib
	# ok, now we detect what to ship
	mkdir -p $(CURDIR)/debian/tmp/usr/share/pixmaps
	cp debian/coq.xpm debian/tmp/usr/share/pixmaps/coqide.xpm
	find debian/tmp -regextype posix-awk \
	  -regex '.*\.(cma|cmxs)$$' \
	  >> debian/libcoq-ocaml.install
	find debian/tmp -regextype posix-awk \
	  -regex '.*\.(a|cmi|cmo|cmt|cmti|cmx|cmxa|ml|mli|o])$$' \
	  >> debian/libcoq-ocaml-dev.install
	find debian/tmp -regextype posix-awk \
	  -regex '.*\.(v|vo|vos|glob)$$' \
	  >> debian/coq-theories.install

# to make dh-exec work
override_dh_install:
	chmod +x debian/coq.install
	dh_install

override_dh_gencontrol:
	for u in $(PACKAGES); do \
	  echo 'F:OCamlABI=$(OCAML_ABI)' >> debian/$$u.substvars; \
	  echo 'F:CoqABI=$(COQ_ABI)' >> debian/$$u.substvars; \
	done
	dh_gencontrol

override_dh_strip:
	# usual dh_strip finds lib*.a, not *.a
	find debian/ -name "*.a" -exec strip '{}' \;
	dh_strip

# why is this necessary?
override_dh_fixperms:
	dh_fixperms
	find $(CURDIR)/debian -name TimeFileMaker.py -exec chmod -x '{}' \;

## coq 8.14.1+dfsg

=== test-suite/Makefile ===
##########################################################################
##         #   The Coq Proof Assistant / The Coq Development Team       ##
##  v      #         Copyright INRIA, CNRS and contributors             ##
## <O___,, # (see version control and CREDITS file for authors & dates) ##
##   \VV/  ###############################################################
##    //   #    This file is distributed under the terms of the         ##
##         #     GNU Lesser General Public License Version 2.1          ##
##         #     (see LICENSE file for the text of the license)         ##
##########################################################################

# There is one %.v.log target per %.v test file. The target will be
# filled with the output, timings and status of the test. There is
# also one target per directory containing %.v files, that runs all
# the tests in it. As convenience, there is also the "bugs" target
# that runs all bug-related tests.

# The "summary" target outputs a summary of all tests that were run
# (but doesn't run them)

# The "run" target runs all tests that have not been run yet. To force
# all tests to be run, use the "clean" target.

# Setup for Dune-build ML artifacts
COQ_SRC_DIR:=..

###########################################################################
# Includes
###########################################################################

-include ../config/Makefile

#######################################################################
# Variables
#######################################################################

# Using quotes to anticipate the possibility of spaces in the directory name
# Note that this will later need an eval in shell to interpret the quotes
ROOT='$(shell cd ..; pwd)'

BIN:=$(ROOT)/_build/install/default/bin/

# An alternative is ifeq ($(OS),Windows_NT) using make's own variable.
ifeq ($(ARCH),win32)
  export FINDLIB_SEP=;
else
  export FINDLIB_SEP=:
endif

# Be careful to use COQPREFIX when prefix is not set
ifeq ($(COQPREFIX),local)
	COQPREFIX:=$(shell cd ../..;pwd)/install/default/
endif

export OCAMLPATH := $(shell echo $(COQPREFIX)/lib$(FINDLIB_SEP)$$OCAMLPATH)
export CAML_LD_LIBRARY_PATH:=$(COQPREFIX)/lib/stublibs:$(CAML_LD_LIBRARY_PATH)

ifneq ($(wildcard ../_build/default/config/Makefile),)
include ../_build/default/config/Makefile
endif

# COQLIB is an env variable so no quotes
COQLIB?=
ifeq ($(COQLIB),)
	COQLIB := $(shell ocaml ocaml_pwd.ml $(COQLIBINSTALL))
endif
export COQLIB

COQEXTRAFLAGS?=
COQFLAGS?=$(COQEXTRAFLAGS)

coqc := $(BIN)coqc -q -R prerequisite TestSuite $(COQFLAGS)
coqchk := $(BIN)coqchk -R prerequisite TestSuite
coqdoc := $(BIN)coqdoc
coqtop := $(BIN)coqtop -q -test-mode -R prerequisite TestSuite
coqtopbyte := $(BIN)coqtop.byte -q

ifeq ($(BEST),opt)
coqidetop := $(BIN)coqidetop.opt
else
coqidetop := $(BIN)coqidetop.byte
endif

coqc_interactive := $(coqc) -test-mode -async-proofs-cache force
coqdep := $(BIN)coqdep

# This is the convention for coq_makefile
OPT=-$(BEST)
export OPT

VERBOSE?=
SHOW := $(if $(VERBOSE),@true,@echo)
HIDE := $(if $(VERBOSE),,@)
REDIR := $(if $(VERBOSE),,> /dev/null 2>&1)

# read out an emacs config and look for coq-prog-args; if such exists, return it
get_coq_prog_args_helper = sed -n s'/^.*coq-prog-args:[[:space:]]*(\([^)]*\)).*/\1/p' $(1)
get_coq_prog_args = $(strip $(shell $(call get_coq_prog_args_helper,$(1))))
SINGLE_QUOTE="
#" # double up on the quotes, in a comment, to appease the emacs syntax highlighter
# wrap the arguments in parens, but only if they exist
get_coq_prog_args_in_parens = $(subst $(SINGLE_QUOTE),,$(if $(call get_coq_prog_args,$(1)), ($(call get_coq_prog_args,$(1)))))
get_set_impredicativity= $(filter "-impredicative-set",$(call get_coq_prog_args,$(1)))

bogomips:=
ifneq (,$(wildcard /proc/cpuinfo))
  sedbogo := -e "s/bogomips.*: \([0-9]*\).*/\1/p" # i386, ppc
  sedbogo += -e "s/Cpu0Bogo.*: \([0-9]*\).*/\1/p" # sparc
  sedbogo += -e "s/BogoMIPS.*: \([0-9]*\).*/\1/p" # alpha
  bogomips := $(shell sed -n $(sedbogo) /proc/cpuinfo | head -1)
endif

ifeq (,$(bogomips))
  $(warning cannot run complexity tests (no bogomips found))
endif

# keep these synced with test-suite/save-logs.sh
log_success = "==========> SUCCESS <=========="
log_segfault = "==========> FAILURE <=========="
log_anomaly = "==========> FAILURE <=========="
log_failure = "==========> FAILURE <=========="
log_intro = "==========> TESTING $(1) <=========="

FAIL = >&2 echo 'FAILED    $@'

#######################################################################
# Testing subsystems
#######################################################################

# These targets can be skipped by doing `make TARGET= test-suite`
COMPLEXITY := $(if $(bogomips),complexity)
BUGS := bugs/opened bugs/closed
INTERACTIVE := interactive
UNIT_TESTS := unit-tests
VSUBSYSTEMS := prerequisite success failure $(BUGS) output output-coqtop \
  output-modulo-time $(INTERACTIVE) micromega $(COMPLEXITY) modules stm \
  coqdoc ssr $(wildcard primitive/*) ltac2

# All subsystems
SUBSYSTEMS := $(VSUBSYSTEMS) misc ide bugs ide vio coqchk output-coqchk coqwc coq-makefile tools $(UNIT_TESTS)

.csdp.cache: .csdp.cache.test-suite
	cp $< $@
	chmod u+w $@

PREREQUISITELOG = $(addsuffix .log,$(wildcard prerequisite/*.v)) .csdp.cache

#######################################################################
# Phony targets
#######################################################################

.DELETE_ON_ERROR:
.PHONY: all run clean $(SUBSYSTEMS)

all: run
	$(MAKE) report

# do nothing
.PHONY: noop
noop: ;

run: $(SUBSYSTEMS)
bugs: $(BUGS)

clean:
	rm -f trace .csdp.cache .nia.cache .lia.cache output/MExtraction.out
	rm -f vos/Makefile vos/Makefile.conf
	rm -f misc/universes/all_stdlib.v
	$(SHOW) 'RM        <**/*.stamp> <**/*.vo> <**/*.vio> <**/*.log> <**/*.glob>'
	$(HIDE)find . \( \
	  -name '*.stamp' -o -name '*.vo' -o -name '*.vio' -o -name '*.vos' -o -name '*.vok' -o -name '*.log' -o -name '*.glob' \
	  \) -exec rm -f {} +
	$(SHOW) 'RM        <**/*.cmx> <**/*.cmi> <**/*.o> <**/*.test>'
	$(HIDE)find unit-tests \( \
	  -name '*.cmx' -o -name '*.cmi' -o -name '*.o' -o -name '*.test' \
	  \) -exec rm -f {} +
distclean: clean
	$(SHOW) 'RM        <**/*.aux>'
	$(HIDE)find . -name '*.aux' -exec rm -f {} +

#######################################################################
# Per-subsystem targets
#######################################################################

define vdeps
$(1): $(patsubst %.v,%.v.log,$(wildcard $(1)/*.v))
endef
$(foreach S,$(VSUBSYSTEMS),$(eval $(call vdeps,$(S))))

#######################################################################
# Summary
#######################################################################

summary_dir = echo $(1); find $(2) -name '*.log' -print0 | xargs -0 -n 1 tail -n1 | sort

.PHONY: summary summary.log

summary:
	@{ \
	  $(call summary_dir, "Preparing tests", prerequisite); \
	  $(call summary_dir, "Success tests", success); \
	  $(call summary_dir, "Failure tests", failure); \
	  $(call summary_dir, "Bugs tests", bugs); \
	  $(call summary_dir, "Output tests", output); \
	  $(call summary_dir, "Output tests with coqtop", output-coqtop); \
	  $(call summary_dir, "Output (modulo time changes) tests", output-modulo-time); \
	  $(call summary_dir, "Interactive tests", interactive); \
	  $(call summary_dir, "Micromega tests", micromega); \
	  $(call summary_dir, "Miscellaneous tests", misc); \
	  $(call summary_dir, "Complexity tests", complexity); \
	  $(call summary_dir, "Module tests", modules); \
	  $(call summary_dir, "Primitive tests", primitive); \
	  $(call summary_dir, "STM tests", stm); \
	  $(call summary_dir, "SSR tests", ssr); \
	  $(call summary_dir, "IDE tests", ide); \
	  $(call summary_dir, "VI tests", vio); \
	  $(call summary_dir, "Coqchk tests", coqchk); \
	  $(call summary_dir, "Output tests with coqchk", output-coqchk); \
	  $(call summary_dir, "Coqwc tests", coqwc); \
	  $(call summary_dir, "Coq makefile", coq-makefile); \
	  $(call summary_dir, "Coqdoc tests", coqdoc); \
	  $(call summary_dir, "tools/ tests", tools); \
	  $(call summary_dir, "Unit tests", unit-tests); \
	  $(call summary_dir, "Ltac2 tests", ltac2); \
	  nb_success=`find . -name '*.log' -exec tail -n2 '{}' \; | grep -e $(log_success) | wc -l`; \
	  nb_failure=`find . -name '*.log' -exec tail -n2 '{}' \; | grep -e $(log_failure) | wc -l`; \
	  nb_tests=`expr $$nb_success + $$nb_failure`; \
	  percentage=`expr 100 \* $$nb_success / $$nb_tests`; \
	  echo; \
	  echo "$$nb_success tests passed over $$nb_tests, i.e. $$percentage %"; \
	}

summary.log:
	$(SHOW) BUILDING SUMMARY FILE
	$(HIDE)$(MAKE) --quiet summary > "$@"

report: summary.log
	$(HIDE)bash report.sh

#######################################################################
# Regression (and progression) tests
#######################################################################

# Process verifications concerning submitted bugs. A message is
# printed for all opened bugs (still active or seems to be closed).
# For closed bugs that behave as expected, no message is printed

# All files are assumed to have bug_<# of the bug>.v as a name

# Opened bugs that should not fail
$(addsuffix .log,$(wildcard bugs/opened/*.v)): %.v.log: %.v
	@echo "TEST      $<  $(call get_coq_prog_args_in_parens,"$<")"
	$(HIDE){ \
	  echo $(call log_intro,$<); \
	  $(coqc) "$<" $(call get_coq_prog_args,"$<") 2>&1; R=$$?; times; \
	  if [ $$R = 0 ]; then \
	    echo $(log_success); \
	    echo "    $<...still active"; \
	  elif [ $$R = 129 ]; then \
	    echo $(log_anomaly); \
	    echo "    $<...still active"; \
	  elif [ $$R = 139 ]; then \
	    echo $(log_segfault); \
	    echo "    $<...still active"; \
	  else \
	    echo $(log_failure); \
	    echo "    $<...Error! (bug seems to be closed, please check)"; \
	    $(FAIL); \
	  fi; \
	} > "$@"

# Closed bugs that should succeed
$(addsuffix .log,$(wildcard bugs/closed/*.v)): %.v.log: %.v
	@echo "TEST      $< $(call get_coq_prog_args_in_parens,"$<")"
	$(HIDE){ \
	  echo $(call log_intro,$<); \
	  (echo "\
	     bugs/closed/bug_3783.v \
	     bugs/closed/bug_4157.v \
	     bugs/closed/bug_5127.v \
	   " | grep -q "$<") && no_native="-native-compiler no"; \
	  $(coqc) $$no_native "$<" $(call get_coq_prog_args,"$<") 2>&1; R=$$?; times; \
	  if [ $$R = 0 ]; then \
	    echo $(log_success); \
	    echo "    $<...Ok"; \
	  else \
	    echo $(log_failure); \
	    echo "    $<...Error! (bug seems to be opened, please check)"; \
	    $(FAIL); \
	  fi; \
	} > "$@"

#######################################################################
# Unit tests
#######################################################################

# COQLIBINSTALL is quoted in config/make thus we must unquote it,
# otherwise the directory name will include the quotes, see
# see for example https://stackoverflow.com/questions/10424645/how-to-convert-a-quoted-string-to-a-normal-one-in-makefile

OCAMLOPT := $(OCAMLFIND) opt $(CAMLFLAGS)
OCAMLC := $(OCAMLFIND) ocamlc $(CAMLFLAGS)

# ML files from unit-test framework, not containing tests
UNIT_SRCFILES:=$(shell find ./unit-tests/src -name '*.ml')
UNIT_ALLMLFILES:=$(shell find ./unit-tests -name '*.ml')
UNIT_MLFILES:=$(filter-out $(UNIT_SRCFILES),$(UNIT_ALLMLFILES))
UNIT_LOGFILES:=$(patsubst %.ml,%.ml.log,$(UNIT_MLFILES))

ifneq ($(BEST),opt)
UNIT_LINK:=utest.cmo
OCAMLBEST:=$(OCAMLC)
else
UNIT_LINK:=utest.cmx
OCAMLBEST:=$(OCAMLOPT)
endif

unit-tests/src/utest.cmx: unit-tests/src/utest.ml unit-tests/src/utest.cmi
	$(SHOW) 'OCAMLOPT  $<'
	$(HIDE)$(OCAMLOPT) -c -I unit-tests/src -package ounit2 $<
unit-tests/src/utest.cmo: unit-tests/src/utest.ml unit-tests/src/utest.cmi
	$(SHOW) 'OCAMLC  $<'
	$(HIDE)$(OCAMLC) -c -I unit-tests/src -package ounit2 $<
unit-tests/src/utest.cmi: unit-tests/src/utest.mli
	$(SHOW) 'OCAMLC  $<'
	$(HIDE)$(OCAMLC) -package ounit2 -c $<

unit-tests: $(UNIT_LOGFILES)

# Build executable, run it to generate log file

=== debian/changelog ===
coq (8.14.1+dfsg-2) unstable; urgency=medium

  * Make the ocaml libraries available in /usr/lib/ocaml
   (so ocamlfind sees them)

 -- Julien Puydt <jpuydt@debian.org>  Mon, 17 Jan 2022 08:54:23 +0100

coq (8.14.1+dfsg-1) unstable; urgency=medium

  * Ship META in the right package and hence Suggest: ocaml-findlib
   (following OCaml Packaging Policy).
  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 11 Dec 2021 11:46:49 +0100

coq (8.14.0+dfsg-6) unstable; urgency=medium

  * Still missed bytecode-only architectures for some packages...

 -- Julien Puydt <jpuydt@debian.org>  Tue, 16 Nov 2021 08:35:39 +0100

coq (8.14.0+dfsg-5) unstable; urgency=medium

  * Missed two bytecode-only architectures.

 -- Julien Puydt <jpuydt@debian.org>  Tue, 16 Nov 2021 07:33:35 +0100

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,7 @@
 
 include /usr/share/ocaml/ocamlvars.mk
 
-COQ_VERSION := 8.14.0
+COQ_VERSION := 8.14.1
 COQ_ABI := $(COQ_VERSION)+$(OCAML_ABI)
 
 PACKAGES := $(shell dh_listpackages)

## coq 8.15.0%2Bdfsg

=== test-suite/Makefile ===
--- 
+++ 
@@ -20,14 +20,18 @@
 # The "run" target runs all tests that have not been run yet. To force
 # all tests to be run, use the "clean" target.
 
-# Setup for Dune-build ML artifacts
-COQ_SRC_DIR:=..
-
 ###########################################################################
 # Includes
 ###########################################################################
 
+# If Coq is not configured, we can't run the makefile.
+ifneq ($(wildcard ../config/Makefile ../_build/default/config/Makefile),)
+-include ../_build/default/config/Makefile
 -include ../config/Makefile
+  COQ_NOT_CONFIGURED:=false
+else
+  COQ_NOT_CONFIGURED:=true
+endif
 
 #######################################################################
 # Variables
@@ -46,24 +50,28 @@
   export FINDLIB_SEP=:
 endif
 
-# Be careful to use COQPREFIX when prefix is not set
-ifeq ($(COQPREFIX),local)
-	COQPREFIX:=$(shell cd ../..;pwd)/install/default/
-endif
-
+# The $(shell echo) trick is necessary due to configure quoting
+# filenames, still, this issue is tricky when paths contain spaces
 export OCAMLPATH := $(shell echo $(COQPREFIX)/lib$(FINDLIB_SEP)$$OCAMLPATH)
-export CAML_LD_LIBRARY_PATH:=$(COQPREFIX)/lib/stublibs:$(CAML_LD_LIBRARY_PATH)
-
-ifneq ($(wildcard ../_build/default/config/Makefile),)
-include ../_build/default/config/Makefile
-endif
+export CAML_LD_LIBRARY_PATH:=$(shell echo $(COQPREFIX)/lib/stublibs):$(CAML_LD_LIBRARY_PATH)
 
 # COQLIB is an env variable so no quotes
 COQLIB?=
+
 ifeq ($(COQLIB),)
+# Guard againt the COQLIBINSTALL directory not existing, otherwise
+# ocaml_pwd will error
+ifneq ($(wildcard $(shell echo $(COQLIBINSTALL))),)
 	COQLIB := $(shell ocaml ocaml_pwd.ml $(COQLIBINSTALL))
 endif
+endif
 export COQLIB
+
+ifeq ($(wildcard $(COQLIB)/theories/Reals/Reals.vo),)
+  COQLIB_NOT_FOUND:=true
+else
+  COQLIB_NOT_FOUND:=false
+endif
 
 COQEXTRAFLAGS?=
 COQFLAGS?=$(COQEXTRAFLAGS)
@@ -151,19 +159,38 @@
 .DELETE_ON_ERROR:
 .PHONY: all run clean $(SUBSYSTEMS)
 
+ifeq ($(COQ_NOT_CONFIGURED),true)
+all:
+	@echo ""
+	@echo "Coq has not been configured, please run any of: "
+	@echo "  - make -f Makefile.dune world"
+	@echo "  - ./configure -profile devel && make -j NJOBS world"
+	@echo "Before running the test suite"
+	@echo ""
+	@false
+else
+ifeq ($(COQLIB_NOT_FOUND),true)
+all:
+	@echo ""
+	@echo "Coq's standard library has not been built; please run any of: "
+	@echo "  - make -j NJOBS world          if you used -profile devel in configure"
+	@echo "  - make -f Makefile.dune world  if you want to use dune autogenerated configure setup"
+	@echo ""
+	@false
+else
 all: run
 	$(MAKE) report
+endif
+endif
 
 # do nothing
 .PHONY: noop
 noop: ;
 
 run: $(SUBSYSTEMS)
-bugs: $(BUGS)
 
 clean:
 	rm -f trace .csdp.cache .nia.cache .lia.cache output/MExtraction.out
-	rm -f vos/Makefile vos/Makefile.conf
 	rm -f misc/universes/all_stdlib.v
 	$(SHOW) 'RM        <**/*.stamp> <**/*.vo> <**/*.vio> <**/*.log> <**/*.glob>'
 	$(HIDE)find . \( \
@@ -300,30 +327,3 @@
 OCAMLOPT := $(OCAMLFIND) opt $(CAMLFLAGS)
 OCAMLC := $(OCAMLFIND) ocamlc $(CAMLFLAGS)
 
-# ML files from unit-test framework, not containing tests
-UNIT_SRCFILES:=$(shell find ./unit-tests/src -name '*.ml')
-UNIT_ALLMLFILES:=$(shell find ./unit-tests -name '*.ml')
-UNIT_MLFILES:=$(filter-out $(UNIT_SRCFILES),$(UNIT_ALLMLFILES))
-UNIT_LOGFILES:=$(patsubst %.ml,%.ml.log,$(UNIT_MLFILES))
-
-ifneq ($(BEST),opt)
-UNIT_LINK:=utest.cmo
-OCAMLBEST:=$(OCAMLC)
-else
-UNIT_LINK:=utest.cmx
-OCAMLBEST:=$(OCAMLOPT)
-endif
-
-unit-tests/src/utest.cmx: unit-tests/src/utest.ml unit-tests/src/utest.cmi
-	$(SHOW) 'OCAMLOPT  $<'
-	$(HIDE)$(OCAMLOPT) -c -I unit-tests/src -package ounit2 $<
-unit-tests/src/utest.cmo: unit-tests/src/utest.ml unit-tests/src/utest.cmi
-	$(SHOW) 'OCAMLC  $<'
-	$(HIDE)$(OCAMLC) -c -I unit-tests/src -package ounit2 $<
-unit-tests/src/utest.cmi: unit-tests/src/utest.mli
-	$(SHOW) 'OCAMLC  $<'
-	$(HIDE)$(OCAMLC) -package ounit2 -c $<
-
-unit-tests: $(UNIT_LOGFILES)
-
-# Build executable, run it to generate log file

## coq 8.15.0+dfsg

=== Makefile ===
##########################################################################
##         #   The Coq Proof Assistant / The Coq Development Team       ##
##  v      #         Copyright INRIA, CNRS and contributors             ##
## <O___,, # (see version control and CREDITS file for authors & dates) ##
##   \VV/  ###############################################################
##    //   #    This file is distributed under the terms of the         ##
##         #     GNU Lesser General Public License Version 2.1          ##
##         #     (see LICENSE file for the text of the license)         ##
##########################################################################

# The default build system is make-based one.
ifndef COQ_USE_DUNE
include Makefile.make
else
ifdef OPAM_PACKAGE_NAME # installing through opam: ignore COQ_USE_DUNE
include Makefile.make
else
include Makefile.dune
endif
endif

=== test-suite/coq-makefile/findlib-package-unpacked/findlib/foo/Makefile ===
-include ../../Makefile.conf

CO="$(COQMF_OCAMLFIND)" opt
CB="$(COQMF_OCAMLFIND)" ocamlc

all:
	$(CO) -c foolib.ml
	$(CO) -a foolib.cmx -o foo.cmxa
	$(CB) -c foolib.ml
	$(CB) -a foolib.cmo -o foo.cma
	$(CB) -c foo.mli # empty .mli file, to be understood

clean:
	rm -f *.cmo *.cma *.cmx *.cmxa *.cmi *.o *.a

=== debian/changelog ===
coq (8.15.0+dfsg-2) unstable; urgency=medium

  * Rework binary packages so they follow more closely
  upstream's view of its "packages".

 -- Julien Puydt <jpuydt@debian.org>  Fri, 04 Feb 2022 08:54:41 +0100

coq (8.15.0+dfsg-1) unstable; urgency=medium

  * New upstream release. (Closes: #1003586)
  * Refresh patches.
  * Refresh lintian overrides.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 17 Jan 2022 12:26:54 +0100

=== debian/control ===
--- 
+++ 
@@ -16,6 +16,7 @@
  dh-python,
  ocaml-dune,
  ocaml-nox (>= 4.05),
+ ocaml-native-compilers,
  ocaml-findlib (>= 1.8.0),
  camlp5 (>= 6.14),
  liblablgtk3-ocaml-dev,
@@ -26,16 +27,15 @@
  python3,
  rsync,
  tex-common
-Build-Conflicts: libcoq-ocaml
 Rules-Requires-Root: no
 Homepage: http://coq.inria.fr/
 Vcs-Browser: https://salsa.debian.org/ocaml-team/coq
 Vcs-Git: https://salsa.debian.org/ocaml-team/coq.git
 
 Package: coq
-Architecture: amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x hurd-i386 ppc64 riscv64
+Architecture: any
 Depends:
- coq-theories (= ${binary:Version}),
+ libcoq-stdlib (= ${binary:Version}),
  ${ocaml:Depends},
  ${python3:Depends},
  ${shlibs:Depends},
@@ -46,7 +46,7 @@
 Suggests:
  coqide | proofgeneral,
  ledit | readline-editor,
- libcoq-ocaml-dev,
+ libcoq-core-ocaml-dev,
  why (>= 2.19),
  coq-doc
 Breaks: coq-libs (<< 8.2.pl1)
@@ -64,7 +64,7 @@
  package to be installed.
 
 Package: coqide
-Architecture: amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x hurd-i386 ppc64 riscv64
+Architecture: any
 Depends:
  coq (= ${binary:Version}),
  ${ocaml:Depends},
@@ -78,12 +78,13 @@
  This package provides CoqIde, a graphical user interface for
  developing proofs.
 
-Package: coq-theories
-Architecture: amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x hurd-i386 ppc64 riscv64
-Depends: coq-${F:CoqABI}, ${misc:Depends}, ${shlibs:Depends}
+Package: libcoq-stdlib
+Architecture: any
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Recommends: coq (>= 8.0)
-Breaks: coq-doc (<= 8.0pl1.0-2), coq-libs (<< 8.2.pl1)
-Replaces: coq-libs (<< 8.2.pl1)
+Provides: coq-theories (= ${binary:Version})
+Breaks: coq-doc (<= 8.0pl1.0-2), coq-libs (<< 8.2.pl1), coq-theories
+Replaces: coq-libs (<< 8.2.pl1), coq-theories
 Description: proof assistant for higher-order logic (theories)
  Coq is a proof assistant for higher-order logic, which allows the
  development of computer programs consistent with their formal
@@ -92,16 +93,17 @@
  This package provides existing theories that new proofs can be
  based upon, including theories of arithmetic and Boolean values.
 
-Package: libcoq-ocaml
+Package: libcoq-core-ocaml
 Section: ocaml
-Architecture: amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x hurd-i386 ppc64 riscv64
+Architecture: any
 Depends:
  ${ocaml:Depends},
  ${shlibs:Depends},
  ${misc:Depends}
-Provides: ${ocaml:Provides}
-Breaks: coq (<< 8.3~), libcoq-ocaml-dev (<< 8.3~), coq-libs
-Replaces: coq (<< 8.3~), libcoq-ocaml-dev (<< 8.3~), coq-libs
+Suggests: ocaml-findlib
+Provides: ${ocaml:Provides}, libcoq-ocaml (= ${binary:Version})
+Breaks: coq (<< 8.3~), libcoq-ocaml-dev (<< 8.3~), coq-libs, libcoq-ocaml
+Replaces: coq (<< 8.3~), libcoq-ocaml-dev (<< 8.3~), coq-libs, libcoq-ocaml
 Description: runtime libraries for Coq
  Coq is a proof assistant for higher-order logic, which allows the
  development of computer programs consistent with their formal
@@ -109,17 +111,17 @@
  .
  This package provides runtime libraries for Coq.
 
-Package: libcoq-ocaml-dev
+Package: libcoq-core-ocaml-dev
 Section: ocaml
-Architecture: amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x hurd-i386 ppc64 riscv64
+Architecture: any
 Depends:
  coq (= ${binary:Version}),
  ${ocaml:Depends},
  ${shlibs:Depends},
  ${misc:Depends}
-Provides: ${ocaml:Provides}
-Breaks: coq (<< 8.2-1+dfsg-1), coq-libs (<< 8.2.pl1)
-Replaces: coq (<< 8.2-1+dfsg-1), coq-libs (<< 8.2.pl1)
+Provides: ${ocaml:Provides}, libcoq-ocaml-dev (= ${binary:Version})
+Breaks: coq (<< 8.2-1+dfsg-1), coq-libs (<< 8.2.pl1), libcoq-ocaml-dev
+Replaces: coq (<< 8.2-1+dfsg-1), coq-libs (<< 8.2.pl1), libcoq-ocaml-dev
 Description: development libraries and tools for Coq
  Coq is a proof assistant for higher-order logic, which allows the
  development of computer programs consistent with their formal

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,7 @@
 
 include /usr/share/ocaml/ocamlvars.mk
 
-COQ_VERSION := 8.14.1
+COQ_VERSION := 8.15.0
 COQ_ABI := $(COQ_VERSION)+$(OCAML_ABI)
 
 PACKAGES := $(shell dh_listpackages)
@@ -23,11 +23,13 @@
 	+dh $@ --with ocaml,python3
 
 override_dh_auto_configure:
-	# none with dune
+	./configure -prefix=/usr -libdir=/usr/lib/ocaml/coq -mandir=/usr/share/man
 
 override_dh_auto_build:
 	dune build -p coq-core,coq-stdlib,coqide-server,coqide --display=verbose
+	# we don't really have the full documentation
 	dune build @stdlib-html --display=verbose
+	touch _build/default/coq-doc.install
 	# all the html files point to the same logo - ship it and point to it
 	cp ide/coqide/coq.png _build/default/doc/stdlib/html/logo.png
 	find _build/default/doc/stdlib/html/ -name "*.html" | xargs sed -i -e "s,//coq.inria.fr/files/barron_logo.png,logo.png,g"
@@ -59,36 +61,30 @@
 
 override_dh_auto_install:
 	dune install coq-core coq-stdlib coqide-server coqide \
-		--destdir=$(CURDIR)/debian/tmp --prefix=/usr --mandir=/usr/share/man
+		--destdir=$(CURDIR)/debian/tmp --prefix=/usr --libdir=/usr/lib/ocaml --mandir=/usr/share/man
 	mkdir -p $(CURDIR)/debian/tmp/usr/doc/coq-stdlib/html
 	install -m 644 _build/default/doc/stdlib/html/* $(CURDIR)/debian/tmp/usr/doc/coq-stdlib/html
 	# cleaning what upstream installs and we don't (need to) ship
-	rm -rf  $(CURDIR)/debian/tmp/usr/doc/coq-core/LICENSE \
-		$(CURDIR)/debian/tmp/usr/doc/coqide/odoc-pages \
-		$(CURDIR)/debian/tmp/usr/doc/coqide/LICENSE \
+	find $(CURDIR)/debian/tmp -name LICENSE -delete
+	rm -rf  $(CURDIR)/debian/tmp/usr/doc/coqide/odoc-pages \
+		$(CURDIR)/debian/tmp/usr/doc/coq-stdlib/odoc-pages \
+		$(CURDIR)/debian/tmp/usr/lib/ocaml/coq-core/revision \
 		$(CURDIR)/debian/tmp/usr/doc/coqide-server \
-		$(CURDIR)/debian/tmp/usr/doc/coq-stdlib/LICENSE \
-		$(CURDIR)/debian/tmp/usr/doc/coq-stdlib/odoc-pages \
-		$(CURDIR)/debian/tmp/usr/lib/coq-core/revision \
-		$(CURDIR)/debian/tmp/usr/lib/coqide \
-		$(CURDIR)/debian/tmp/usr/lib/coqide-server \
-		$(CURDIR)/debian/tmp/usr/lib/coq-stdlib
+		$(CURDIR)/debian/tmp/usr/lib/ocaml/coqide-server
 	# ok, now we detect what to ship
-	mkdir -p $(CURDIR)/debian/tmp/usr/share/pixmaps
-	cp debian/coq.xpm debian/tmp/usr/share/pixmaps/coqide.xpm
-	find debian/tmp -regextype posix-awk \
+	find debian/tmp/usr/lib/ocaml/coq-core -regextype posix-awk \
 	  -regex '.*\.(cma|cmxs)$$' \
-	  >> debian/libcoq-ocaml.install
-	find debian/tmp -regextype posix-awk \
+	  >> debian/libcoq-core-ocaml.install
+	find debian/tmp/usr/lib/ocaml/coq-core -regextype posix-awk \
 	  -regex '.*\.(a|cmi|cmo|cmt|cmti|cmx|cmxa|ml|mli|o])$$' \
-	  >> debian/libcoq-ocaml-dev.install
+	  >> debian/libcoq-core-ocaml-dev.install
 	find debian/tmp -regextype posix-awk \
 	  -regex '.*\.(v|vo|vos|glob)$$' \
-	  >> debian/coq-theories.install
+	  >> debian/libcoq-stdlib.install
 
 # to make dh-exec work
 override_dh_install:
-	chmod +x debian/coq.install
+	chmod +x debian/coq.install debian/coqide.install
 	dh_install
 
 override_dh_gencontrol:

=== debian/watch ===
version=4
opts="\
dversionmangle=s/\+dfsg.*$//,\
filenamemangle=s/.+\/[vV]?(\d\S+)\.tar\.gz/coq-$1\.tar\.gz/,\
repack,repacksuffix=+dfsg,\
" \
https://github.com/coq/coq/releases .*/[vV]?(\d[^\s+]+)\.tar\.gz

## coq 8.15.1+dfsg

=== debian/changelog ===
coq (8.15.1+dfsg-2) unstable; urgency=medium

  * Don't strip everything!
  * Add a patch to fix a typo.
  * Bump standards-version to 4.6.1.

 -- Julien Puydt <jpuydt@debian.org>  Fri, 20 May 2022 15:53:07 +0200

coq (8.15.1+dfsg-1) unstable; urgency=medium

  * Better d/watch.
  * New upstream release.
  * Refresh patches.

 -- Julien Puydt <jpuydt@debian.org>  Tue, 22 Mar 2022 18:05:26 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  Julien Puydt <jpuydt@debian.org>,
  Ralf Treinen <treinen@debian.org>,
  Stéphane Glondu <glondu@debian.org>
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Build-Depends:
  bash (>= 5.0),
  debhelper-compat (= 13),

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,7 @@
 
 include /usr/share/ocaml/ocamlvars.mk
 
-COQ_VERSION := 8.15.0
+COQ_VERSION := 8.15.1
 COQ_ABI := $(COQ_VERSION)+$(OCAML_ABI)
 
 PACKAGES := $(shell dh_listpackages)
@@ -94,11 +94,6 @@
 	done
 	dh_gencontrol
 
-override_dh_strip:
-	# usual dh_strip finds lib*.a, not *.a
-	find debian/ -name "*.a" -exec strip '{}' \;
-	dh_strip
-
 # why is this necessary?
 override_dh_fixperms:
 	dh_fixperms

## coq 8.15.2+dfsg

=== debian/changelog ===
coq (8.15.2+dfsg-2) unstable; urgency=medium

  * Use dh-coq.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 11 Jun 2022 16:16:14 +0200

coq (8.15.2+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Tue, 31 May 2022 21:39:53 +0200

=== debian/control ===
--- 
+++ 
@@ -11,6 +11,7 @@
 Build-Depends:
  bash (>= 5.0),
  debhelper-compat (= 13),
+ dh-coq,
  dh-exec,
  dh-ocaml (>= 0.9.5~),
  dh-python,
@@ -82,7 +83,7 @@
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Recommends: coq (>= 8.0)
-Provides: coq-theories (= ${binary:Version})
+Provides: coq-theories (= ${binary:Version}), ${coq:Provides}
 Breaks: coq-doc (<= 8.0pl1.0-2), coq-libs (<< 8.2.pl1), coq-theories
 Replaces: coq-libs (<< 8.2.pl1), coq-theories
 Description: proof assistant for higher-order logic (theories)

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,7 @@
 
 include /usr/share/ocaml/ocamlvars.mk
 
-COQ_VERSION := 8.15.1
+COQ_VERSION := 8.15.2
 COQ_ABI := $(COQ_VERSION)+$(OCAML_ABI)
 
 PACKAGES := $(shell dh_listpackages)
@@ -17,10 +17,7 @@
   -e 's%@CoqABI@%$(COQ_ABI)%'
 
 %:
-	+dh $@ --with ocaml,python3
-
-build:
-	+dh $@ --with ocaml,python3
+	+dh $@ --with coq,ocaml,python3
 
 override_dh_auto_configure:
 	./configure -prefix=/usr -libdir=/usr/lib/ocaml/coq -mandir=/usr/share/man

## coq 8.16.0+dfsg

=== debian/changelog ===
coq (8.16.0+dfsg-1build1) lunar; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 25 Nov 2022 07:41:35 +0100

coq (8.16.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 05 Sep 2022 17:56:26 +0200

=== debian/control ===
--- 
+++ 
@@ -20,6 +20,7 @@
  ocaml-native-compilers,
  ocaml-findlib (>= 1.8.0),
  camlp5 (>= 6.14),
+ libfindlib-ocaml-dev,
  liblablgtk3-ocaml-dev,
  liblablgtksourceview3-ocaml-dev (>= 3.0~beta8),
  libnum-ocaml-dev,

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,7 @@
 
 include /usr/share/ocaml/ocamlvars.mk
 
-COQ_VERSION := 8.15.2
+COQ_VERSION := 8.16.0
 COQ_ABI := $(COQ_VERSION)+$(OCAML_ABI)
 
 PACKAGES := $(shell dh_listpackages)

## coq 8.16.1+dfsg

=== debian/changelog ===
coq (8.16.1+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Tue, 29 Nov 2022 09:28:08 +0100

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,7 @@
 
 include /usr/share/ocaml/ocamlvars.mk
 
-COQ_VERSION := 8.16.0
+COQ_VERSION := 8.16.1
 COQ_ABI := $(COQ_VERSION)+$(OCAML_ABI)
 
 PACKAGES := $(shell dh_listpackages)

## coq 8.17.0+dfsg

=== debian/changelog ===
coq (8.17.0+dfsg-1build2) noble; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 05 Nov 2023 08:05:46 +0100

coq (8.17.0+dfsg-1build1) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 24 Jul 2023 19:05:45 +0200

coq (8.17.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Refresh lintian overrides.
  * Fix build.
  * Bump standards-version to 4.6.2.
  * Add patch to workaround a problem in coq-unimath.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 12 Jun 2023 08:54:21 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  Julien Puydt <jpuydt@debian.org>,
  Ralf Treinen <treinen@debian.org>,
  Stéphane Glondu <glondu@debian.org>
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Build-Depends:
  bash (>= 5.0),
  debhelper-compat (= 13),

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,7 @@
 
 include /usr/share/ocaml/ocamlvars.mk
 
-COQ_VERSION := 8.16.1
+COQ_VERSION := 8.17.0
 COQ_ABI := $(COQ_VERSION)+$(OCAML_ABI)
 
 PACKAGES := $(shell dh_listpackages)
@@ -23,6 +23,7 @@
 	./configure -prefix=/usr -libdir=/usr/lib/ocaml/coq -mandir=/usr/share/man
 
 override_dh_auto_build:
+	make dunestrap
 	dune build -p coq-core,coq-stdlib,coqide-server,coqide --display=verbose
 	# we don't really have the full documentation
 	dune build @stdlib-html --display=verbose

## coq 8.18.0%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: coq
 Section: math
 Priority: optional
-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders:
  Benjamin Barenblat <bbaren@debian.org>,
  Julien Puydt <jpuydt@debian.org>,
@@ -9,17 +10,15 @@
  Stéphane Glondu <glondu@debian.org>
 Standards-Version: 4.6.2
 Build-Depends:
- bash (>= 5.0),
  debhelper-compat (= 13),
  dh-coq,
  dh-exec,
- dh-ocaml (>= 0.9.5~),
+ dh-ocaml,
  dh-python,
  ocaml-dune,
- ocaml-nox (>= 4.05),
+ ocaml,
  ocaml-native-compilers,
  ocaml-findlib (>= 1.8.0),
- camlp5 (>= 6.14),
  libfindlib-ocaml-dev,
  liblablgtk3-ocaml-dev,
  liblablgtksourceview3-ocaml-dev (>= 3.0~beta8),
@@ -42,7 +41,7 @@
  ${python3:Depends},
  ${shlibs:Depends},
  ${misc:Depends},
- ocaml-nox,
+ ocaml,
  ocaml-findlib
 Provides: coq-${F:CoqABI}
 Suggests:
@@ -83,7 +82,7 @@
 Package: libcoq-stdlib
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Recommends: coq (>= 8.0)
+Recommends: coq
 Provides: coq-theories (= ${binary:Version}), ${coq:Provides}
 Breaks: coq-doc (<= 8.0pl1.0-2), coq-libs (<< 8.2.pl1), coq-theories
 Replaces: coq-libs (<< 8.2.pl1), coq-theories
@@ -104,8 +103,8 @@
  ${misc:Depends}
 Suggests: ocaml-findlib
 Provides: ${ocaml:Provides}, libcoq-ocaml (= ${binary:Version})
-Breaks: coq (<< 8.3~), libcoq-ocaml-dev (<< 8.3~), coq-libs, libcoq-ocaml
-Replaces: coq (<< 8.3~), libcoq-ocaml-dev (<< 8.3~), coq-libs, libcoq-ocaml
+Breaks: coq-libs, libcoq-ocaml
+Replaces: coq-libs, libcoq-ocaml
 Description: runtime libraries for Coq
  Coq is a proof assistant for higher-order logic, which allows the
  development of computer programs consistent with their formal
@@ -122,8 +121,8 @@
  ${shlibs:Depends},
  ${misc:Depends}
 Provides: ${ocaml:Provides}, libcoq-ocaml-dev (= ${binary:Version})
-Breaks: coq (<< 8.2-1+dfsg-1), coq-libs (<< 8.2.pl1), libcoq-ocaml-dev
-Replaces: coq (<< 8.2-1+dfsg-1), coq-libs (<< 8.2.pl1), libcoq-ocaml-dev
+Breaks: coq-libs (<< 8.2.pl1), libcoq-ocaml-dev
+Replaces: coq-libs (<< 8.2.pl1), libcoq-ocaml-dev
 Description: development libraries and tools for Coq
  Coq is a proof assistant for higher-order logic, which allows the
  development of computer programs consistent with their formal
